<?php
class mosaic_generator_class
{
    var $options;
    var $images_array;
  
    function get_all_options()
    {
        $this->options = get_option('mosaic_generator_options');
        if(!(get_option('mosaic_generator_images_array')))
        {$this->create_images_for_mosaic();}
        else
        {$this->images_array = get_option('mosaic_generator_images_array');}        
    }
    
    function main_generate($options, $images_array, $flag_regenerate = false)
    {     
        if($this->options['generating_type']=='div')
        {                                    
            if($flag_regenerate)
            {    
                $code = '<div class="mosaic_generate_main">';        
                for($j = 1;$j <= $options['height_count'];$j++)
                {
                    if(count($images_array)==0)
                    {
                        $code.='</div>';
                        return $code;    
                    }
                                
                    for($i = 1;$i <= $options['width_count'];$i++)
                    {
                        
                        if(count($images_array)==0)
                        {
                            $code.='</div>';
                            return $code;    
                        }
                        $mosaic_generator_rnd_index = mt_rand(0, count($images_array) - 1);                    
                        $tmp_image_src = $images_array[$mosaic_generator_rnd_index];
                        unset($images_array[$mosaic_generator_rnd_index]);
                        $images_array = array_values($images_array);
    
                        if($i == 1)
                        {
                            if(!(empty($tmp_image_src)))
                            {
                                $code.='<div class="mosaic_generator_last_in_line mosaic_generator_img" style="height: '.$options['size'].'px; width: '.$this->options['size'].'px;"><img src="'.$tmp_image_src.'"/></div>';                    
                            }
                        } 
                        else
                        {
                            if(!(empty($tmp_image_src)))
                            {
                                $code.='<div class="mosaic_generator_img" style="height: '.$this->options['size'].'px; width: '.$options['size'].'px;"><img src="'.$tmp_image_src.'"/></div>';   
                            }                
                        }                          
                    }                        
                }
                $code.='</div>';      
                $code.='<div style="clear: both;"></div>';
   	            
                $f = fopen(MOSAIC_GENERATOR_PLUGIN_IMAGES_DIR.'code.txt', "w");
            	fwrite($f, $code); 
            	fclose($f);
            }
            else
            {
                if (file_exists(MOSAIC_GENERATOR_PLUGIN_IMAGES_DIR.'code.txt'))
                {
                    
                    $code = $this->get_ready_code();    
                }
                else
                {
                    $this->main_generate($this->options, $this->images_array, true);
                    $code = $this->get_ready_code();
                }        
            }
        }
        else
        {
            if($flag_regenerate)
            {    
                $code = '<div class="mosaic_generate_main">';
                $border_size = $options['border_size'];
                $main_img_width = $options['size'] * $options['width_count'] + ($options['width_count']+1)*$border_size;
                $main_img_height = $options['size'] * $options['height_count'] + ($options['height_count']+1)*$border_size;
                
                $main_img = imagecreatetruecolor($main_img_width, $main_img_height);
                $white_color = ImageColorAllocate ($main_img, 255, 255, 255);                 
                imageFilledRectangle($main_img, 0, 0, $main_img_width, $main_img_height, $white_color);     
                
                if(count($images_array) > 0)
                {                                
                    for($j = 1; $j <= $options['height_count']; $j++)
                    {                                        
                        if(count($images_array)==0)
                        {                            
                            return $this->paste_code($code, $main_img, $options).'</div>';    
                        }
                                    
                        for($i = 1;$i <= $options['width_count']; $i++)
                        {                        
                            if(count($images_array)==0)
                            {
                                return $this->paste_code($code, $main_img, $options).'</div>';    
                            }
                            $mosaic_generator_rnd_index = mt_rand(0, count($images_array) - 1);                    
                            $tmp_image_src = $images_array[$mosaic_generator_rnd_index];
                            unset($images_array[$mosaic_generator_rnd_index]);
                            
                            $images_array = array_values($images_array);
                            $src = @imagecreatefromjpeg($tmp_image_src);                        
                            @imagecopy($main_img, $src, ($i-1)*$options['size'] + ($i*$border_size), ($j-1)*$options['size'] + ($j*$border_size), 0, 0, $options['size'], $options['size']);                                                                             
                        }                                            
                    }
                    $code = $this->paste_code($code, $main_img, $options);
                }
                
                $code.= '</div>';
            }
            else
            {
                $code = '<div class="mosaic_generate_main">';
                $code.= '<img src="'.MOSAIC_GENERATOR_PLUGIN_IMAGES_URL.$options['generating_time'].'main_mosaic_img.jpg'.'" alt="Mosaic Generator (http://omelchuck.ru/mosaic-generator/)"/>';
                $code.= '</div>';                 
            }       
        }
        return $code;        
    }
    
    private function paste_code($code, $main_img, $options)
    {
        @imagejpeg($main_img, MOSAIC_GENERATOR_PLUGIN_IMAGES_DIR.$options['generating_time'].'main_mosaic_img.jpg');
        $code.= '<img src="'.MOSAIC_GENERATOR_PLUGIN_IMAGES_URL.$options['generating_time'].'main_mosaic_img.jpg'.'" alt="Mosaic Generator (http://omelchuck.ru/mosaic-generator/)"/>';
        return $code;        
    } 
    
    function get_ready_code()
    {        
        $file_array = @file ( MOSAIC_GENERATOR_PLUGIN_IMAGES_DIR.'code.txt' );
        if(is_array($file_array))
        {
                $code =  implode("", $file_array);
        }
        else
        {
            $this->main_generate($this->options, $this->images_array, true);
            $code = $this->get_ready_code();            
        }          
        return $code;                
    }
      
    function view_options_page()
    {
        if (isset($_POST['submit']))
        {
            $need_update = false;
            $error = false;
            $error_text = '';
            
            // Check size
            if (is_numeric($_POST['mosaic_generator_options_size']))
            {
                if($_POST['mosaic_generator_options_size']>0)
                {
                    $need_update = true;
                }
                else
                {
                    $error = true;
                    $error_text = ' - Size must be more then zero'.'<br>';                    
                }
            }
            else
            {
                $error = true;
                $error_text = ' - Size must be numeric'.'<br>';   
            }                        
            
            // Check height
            if (is_numeric($_POST['mosaic_generator_options_height_count']))
            {
                if($_POST['mosaic_generator_options_height_count']>0)
                {
                    $need_update = true;
                }
                else
                {
                    $error = true;
                    $error_text.= ' - Height count must be more then zero'.'<br>';                  
                }
            }
            else
            {
                $error = true;
                $error_text.= ' - Height count must be numeric'.'<br>';                 
            } 
            
            // Check width         
            if (is_numeric($_POST['mosaic_generator_options_width_count']))
            {
                if($_POST['mosaic_generator_options_width_count'] > 0)
                {
                    $need_update = true;
                }
                else
                {                    
                    $error = true;
                    $error_text.= ' - Width count must be more then zero'.'<br>';
                }                
            }
            else
            {               
                $error = true;
                $error_text.= ' - Width count must be numeric'.'<br>';                 
            } 
            
            // Check generating type                
            if($_POST['mosaic_generator_options_generating_type']=='div' || $_POST['mosaic_generator_options_generating_type']=='gd')
            {            
                if ($this->options['generating_type'] <> $_POST['mosaic_generator_options_generating_type'])
                {
                    $need_update = true;
                }
            }
            else
            {
                $error = true;
                $error_text.= ' - Generating type = div or gd'.'<br>';                
            }
            
            // Check border size     
            if (is_numeric($_POST['mosaic_generator_options_border_size']))
            {
                if($_POST['mosaic_generator_options_border_size'] >= 0)
                {
                    $need_update = true;
                }
                else
                {
                    $error = true;
                    $error_text.= ' - Border size count must be more or equal zero'.'<br>';                    
                }
            }
            else
            {
                $error = true;
                $error_text.= ' - Border size count must be numeric'.'<br>';                
            }
                
            if($error === false)
            {                   
                if($need_update)
                {
                    $this->update_options($_POST);    
                }
            }                                                                     
        }
        elseif (isset($_POST['create_images']))
        {                    
            $this->options['generating_time'] = time();
            update_option('mosaic_generator_options', $this->options);
            $this->create_images_for_mosaic();
            $this->main_generate($this->options, $this->images_array, true);                        
        }
        elseif (isset($_POST['regenerating']))
        {
            $this->options['generating_time'] = time();
            update_option('mosaic_generator_options', $this->options);            
            $this->main_generate($this->options, $this->images_array, true);                        
        }        
        elseif (isset($_POST['save_view_css']))
        {            
            $this->save_view_css($_POST['mosaic_generator_view_css']);        
        }        
        else
        {
            $this->update_options();
        }
                
        ?>
        <h2>Mosaic preview</h2>
        <p>Refresh the page if you do not reflect the changes.</p>
		<p>Official site: <a href="http://omelchuck.ru/mosaic-generator/">http://omelchuck.ru/mosaic-generator/</a></p>
        <?php echo $this->main_generate($this->options, $this->images_array);?>
        
        <div>
        Paste this code between the end of "header" and "content":<br>
        <pre><code>&lt;?php mosaic_generator();?&gt;</code></pre>
        </div>
        
        For example:</br>
        
        <pre><code class="php">&lt;div id=&quot;header&quot;&gt;any code...&lt;/div&gt;
&lt;?php echo mosaic_generator();?&gt;
&lt;div id=&quot;content&quot;&gt;any code...&lt;/div&gt;</code></pre>
        
        Or paste shortcode <strong>[mosaic_generator]</strong> in post.
        
        <h2>Mosaic Generator options.</h2>
        <div style="clear: both;"></div>        
        <div class="mosaic_generator_admin_forms">
        <?php
            if($error)
            {
                echo '<div class="mosaic_generator_error_text">'.$error_text.'</div>';    
            }        
        ?>
        
            <form name="mosaic_generator_options_form" method="post" action="<?php echo $_SERVER['PHP_SELF'] . '?page=' . MOSAIC_GENERATOR_FILE_BASENAME; ?>&updated=true">
                <div class="mosaic_generator_label">Image size:</div>
        		<input name="mosaic_generator_options_size" type="text" id="mosaic_generator_options_size" value="<?php echo $this->options['size']; ?>" size="3" /> px;
                <div style="clear: both;"></div>
                
                <div class="mosaic_generator_label">Number of images in height:</div>
        		<input name="mosaic_generator_options_height_count" type="text" id="mosaic_generator_options_height_count" value="<?php echo $this->options['height_count']; ?>" size="3" />
               <div style="clear: both;"></div>
                
                <div class="mosaic_generator_label">Number of images in width:</div>
        		<input name="mosaic_generator_options_width_count" type="text" id="mosaic_generator_options_width_count" value="<?php echo $this->options['width_count']; ?>" size="3" />                                                            
                <div style="clear: both;"></div>
                
                <div class="mosaic_generator_label">Border size (for 'image' generating type, for 'div' generating type use style.css):</div>
        		<input name="mosaic_generator_options_border_size" type="text" id="mosaic_generator_options_border_size" value="<?php echo $this->options['border_size']; ?>" size="3" /> px;                                                            
                <div style="clear: both;"></div>
                                
                <hr />
                <div class="mosaic_generator_label">Type of generation:</div><div style="clear: both;"></div>        		    
                    <input name="mosaic_generator_options_generating_type" type="radio" value="div" <?php if($this->options['generating_type']=='div'){echo 'checked="true"';} ?>/>Mosaic in div
                    <div style="clear: both;"></div>                                                         
                    <input name="mosaic_generator_options_generating_type" type="radio" value="gd" <?php if($this->options['generating_type']=='gd'){echo 'checked="true"';} ?>/>Mosaic in Image
                    <div style="clear: both;"></div>                     
                <div style="clear: both;"></div>                                
                <hr />
        		<input class="mosaic_generator_button" type="submit" name="submit" value="<?php _e('Save options') ?>" />
            </form>                
            <form name="mosaic_generator_create_img_form" method="post" action="<?php echo $_SERVER['PHP_SELF'] . '?page=' . MOSAIC_GENERATOR_FILE_BASENAME; ?>">            
                <input class="mosaic_generator_button" type="submit" name="create_images" value="<?php _e('Recreate the images') ?>" />            
            </form>
            
            <form name="mosaic_generator_regenerating_form" method="post" action="<?php echo $_SERVER['PHP_SELF'] . '?page=' . MOSAIC_GENERATOR_FILE_BASENAME; ?>">            
                <input class="mosaic_generator_button" type="submit" name="regenerating" value="<?php _e('Re-Generate Mosaic') ?>" />            
            </form>            
        </div>
        
        <div class="mosaic_generator_css_forms">
            <h2>Edit "style.css".</h2>            
            <form name="mosaic_generator_view_css_forms" method="post" action="<?php echo $_SERVER['PHP_SELF'] . '?page=' . MOSAIC_GENERATOR_FILE_BASENAME; ?>&updated=true">
                <textarea class="mosaic_generator_textarea" name="mosaic_generator_view_css" id="mosaic_generator_admin_css"><?php echo $this->get_view_css(); ?></textarea>
                
                <div style="clear: both;"></div>
                <input class="mosaic_generator_button" type="submit" name="save_view_css" value="<?php _e('Save style.css') ?>" />
            </form>            
        </div>                                           
        <?php        
    }
    
    function get_admin_css()
    { 
        $file_array = @file ( MOSAIC_GENERATOR_PLUGIN_CSS_DIR.'admin_style.css' );
        if(is_array($file_array))
        {
            $content =  implode("", $file_array);
        }
        else
        {
            $content = 'Error, no file or no access to admin_style.css';
        }          
        return $content; 
    }
    
    function save_admin_css($text)
    {   
    	$f = fopen(MOSAIC_GENERATOR_PLUGIN_CSS_DIR.'admin_style.css', "w");
    	fwrite($f, $text); 
    	fclose($f);
    }   
    
    function get_view_css()
    {
        $file_array = @file ( MOSAIC_GENERATOR_PLUGIN_CSS_DIR.'style.css' );
        if(is_array($file_array))
        {
            $content =  implode("", $file_array);
        }
        else
        {
            $content = 'Error, no file or no access to style.css';
        }          
        return $content; 
    }    
    
    function save_view_css($text)
    {   
    	$f = fopen(MOSAIC_GENERATOR_PLUGIN_CSS_DIR.'style.css', "w");
    	fwrite($f, $text); 
    	fclose($f);
        $this->main_generate($this->options, $this->images_array, true);
    }     
    
    function create_images_for_mosaic()
    {
        $this->remove_dir(MOSAIC_GENERATOR_PLUGIN_IMAGES_DIR);                      
        if(!is_dir(MOSAIC_GENERATOR_PLUGIN_IMAGES_DIR))
        {
            if (!mkdir(MOSAIC_GENERATOR_PLUGIN_IMAGES_DIR, 0777, true))
            {die('Failed to create folders for images...');}
        }

        $img_count = $this->options['height_count'] * $this->options['width_count'];
        $args = array( 'post_type' => 'attachment', 'numberposts' => $img_count, 'post_status' => null, 'post_parent' => null, 'post_mime_type' => array('image/jpeg') ); 
        $attachment_array = get_posts( $args );               
        
        $images_array = array();        
        if ($attachment_array)
        {
           	foreach ($attachment_array as $attachment)
            {    	       
                $mosaic_generator_src_img_array = wp_get_attachment_image_src($attachment->ID, 'full');
                if(!(empty($mosaic_generator_src_img_array[0])))
                {                     
                    $mosaic_generator_img_abs_path = $this->get_absolute_path($mosaic_generator_src_img_array[0]);                   
                    $mosaic_generator_new_img_abs_path = image_resize($mosaic_generator_img_abs_path, $this->options['size'], $this->options['size'], TRUE, $this->options['generating_time'], MOSAIC_GENERATOR_PLUGIN_IMAGES_DIR, 100);
                           
                    if(is_wp_error($mosaic_generator_new_img_abs_path))
                    {

                    }
                    else
                    {
                        $path_parts = pathinfo($mosaic_generator_new_img_abs_path);
                        $mosaic_generator_new_image_rel_path = MOSAIC_GENERATOR_PLUGIN_IMAGES_URL.$path_parts['basename'];
                        array_push($images_array, $mosaic_generator_new_image_rel_path);
                    }
                }           
           	}                
        }
        
        if(count($images_array)>0)
        {
            $this->images_array = $images_array;
            
            if(!(get_option('mosaic_generator_images_array')))
            {add_option('mosaic_generator_images_array', $this->images_array);}
            else
            {update_option('mosaic_generator_images_array', $this->images_array);}
        }
                
    }
    
    function get_absolute_path($relative_path)
    {
        $path_parts = pathinfo($relative_path);           
        $tmp_array = explode($_SERVER["SERVER_NAME"], $path_parts['dirname']);
        $absolute_Path = $_SERVER['DOCUMENT_ROOT'].$tmp_array[1].'/'.$path_parts['basename'];
                   
        return $absolute_Path;        
    }
    
    function remove_dir($dir_name)
    {
        if (!file_exists($dir_name)){
            return false;
        }
        if (is_file($dir_name)){
            return unlink($dir_name);
        }
        $dir = dir($dir_name);
        while (false !== $entry = $dir->read()){
            if ($entry == '.' || $entry == '..'){
                continue;
            }
            $this->remove_dir($dir_name . DIRECTORY_SEPARATOR . $entry);
        }
        $dir->close();
        return rmdir($dir_name);        
    }
    
    function update_options($post_array = null)
    {
        $need_update_options = false;
        $need_regenerate_img = false;
        $img_amount_have = $this->options['width_count'] * $this->options['height_count'];
        
        if(is_array($post_array))
        {                       
            if($post_array['mosaic_generator_options_size'] != $this->options['size'])
            {
                $this->options['size'] = $post_array['mosaic_generator_options_size'];
                $need_update_options = true;
                $need_regenerate_img = true;
                $need_regenerate = true;                
            }
            
            if($post_array['mosaic_generator_options_height_count'] != $this->options['height_count'])
            {
                
                $this->options['height_count'] = $post_array['mosaic_generator_options_height_count'];
                $need_update_options = true;
                $need_regenerate = true;                                
            }
            
            if($post_array['mosaic_generator_options_width_count'] != $this->options['width_count'])
            {
                $this->options['width_count'] = $post_array['mosaic_generator_options_width_count'];
                $need_update_options = true;
                $need_regenerate = true;                                
            }
            
            if($img_amount_have <= ($this->options['width_count'] * $this->options['height_count']))
            {
                $need_regenerate_img = true;
                $need_regenerate = true;
            }
            
            if($post_array['mosaic_generator_options_generating_type'] != $this->options['generating_type'])
            {
                $this->options['generating_type'] = $post_array['mosaic_generator_options_generating_type'];
                $need_update_options = true;
                $need_regenerate = true;                                
            } 
            
            if($post_array['mosaic_generator_options_border_size'] != $this->options['border_size'])
            {
                $this->options['border_size'] = $post_array['mosaic_generator_options_border_size'];
                $need_update_options = true;
                if($this->options['generating_type'] == 'gd')
                {
                    $need_regenerate = true;
                }                                
            }                                                                       
        }
        else
        {
            $need_update_options = false;
            if(!(isset($this->options['size']))){$this->options['size'] = 10; $need_update_options = true;}        
            if(!(isset($this->options['height_count']))){$this->options['height_count'] = 3;  $need_update_options = true;}        
            if(!(isset($this->options['width_count']))){$this->options['width_count'] = 10;  $need_update_options = true;}                        
            if(!(isset($this->options['generating_type']))){$this->options['generating_type'] = 'div';  $need_update_options = true;}
            if(!(isset($this->options['border_size']))){$this->options['border_size'] = 1;  $need_update_options = true;}
            if(!(isset($this->options['generating_time']))){$this->options['generating_time'] = time();  $need_update_options = true;}                                           
        }
                
        if($need_regenerate_img)
        {
            $this->options['generating_time'] = time();            
            $need_update_options = true;
            $this->create_images_for_mosaic();
        }

        if($need_regenerate)
        {
            $this->options['generating_time'] = time();
            $this->main_generate($this->options, $this->images_array, true);
        } 
        
        if($need_update_options)
        {
            update_option('mosaic_generator_options', $this->options);                        
        }                                  
    }    
    
    function deactivate()
    {
        delete_option('mosaic_generator_options');
        delete_option('mosaic_generator_images_array');
        $this->remove_dir(MOSAIC_GENERATOR_PLUGIN_IMAGES_DIR);                        
    }    
    
    function activate()
    {
        if(get_option('mosaic_generator_options'))
        {
            delete_option('mosaic_generator_options');    
        }        
        $mosaic_generator_options = array();
        $mosaic_generator_options['size'] = 10;
        $mosaic_generator_options['height_count'] = 3;
        $mosaic_generator_options['width_count'] = 10;
        $mosaic_generator_options['generating_type'] = 'div';
        $mosaic_generator_options['border_size'] = 1;
        $mosaic_generator_options['generating_time'] = time();
        add_option('mosaic_generator_options', $mosaic_generator_options);
        $this->create_images_for_mosaic();         
    }          
}
?>